# 1 "Test06z88dk.c"

# 6
void SetMode0PixelColor(unsigned char *pByteAddress, unsigned char nColor, unsigned char nPixel)
{
unsigned char nByte = *pByteAddress;

if(nPixel == 0)
{
nByte &= 85;

if(nColor & 1)
nByte |= 128;

if(nColor & 2)
nByte |= 8;

if(nColor & 4)
nByte |= 32;

if(nColor & 8)
nByte |= 2;
}
else
{
nByte &= 170;

if(nColor & 1)
nByte |= 64;

if(nColor & 2)
nByte |= 4;

if(nColor & 4)
nByte |= 16;

if(nColor & 8)
nByte |= 1;
}

*pByteAddress = nByte;
}

void PutPixelMode0(unsigned char nX, unsigned char nY, unsigned char nColor)
{
unsigned char nPixel = 0;
unsigned int nAddress = 0xC000 + ((nY / 8) * 80) + ((nY % 8) * 2048) + (nX / 2);
nPixel = nX % 2;

SetMode0PixelColor((unsigned char *)nAddress, nColor, nPixel);
}
# 65
void swap(int n1, int n2)
{
int nAux = n1;
n1 = n2;
n2 = nAux;
}
void lineBresenham(int p1x, int p1y, int p2x, int p2y)
{
int F, x, y;
int dy;
int dx;
int dy2;
int dx2;
int dy2_minus_dx2;
int dy2_plus_dx2;

if (p1x > p2x)
{
swap(p1x, p2x);
swap(p1y, p2y);
}



if (p1x == p2x)
{
if (p1y > p2y)
{
swap(p1y, p2y);
}

x = p1x;
y = p1y;
while (y <= p2y)
{
PutPixelMode0(x, y, 1);
y++;
}
return;
}

else if (p1y == p2y)
{
x = p1x;
y = p1y;

while (x <= p2x)
{
PutPixelMode0(x, y, 1);
x++;
}
return;
}


dy = p2y - p1y;
dx = p2x - p1x;
dy2 = (dy << 1);
dx2 = (dx << 1);
dy2_minus_dx2 = dy2 - dx2;
dy2_plus_dx2 = dy2 + dx2;


if (dy >= 0)
{

if (dy <= dx)
{
F = dy2 - dx;

x = p1x;
y = p1y;
while (x <= p2x)
{
PutPixelMode0(x, y, 1);
if (F <= 0)
{
F += dy2;
}
else
{
y++;
F += dy2_minus_dx2;
}
x++;
}
}


else
{
F = dx2 - dy;

y = p1y;
x = p1x;
while (y <= p2y)
{
PutPixelMode0(x, y, 1);
if (F <= 0)
{
F += dx2;
}
else
{
x++;
F -= dy2_minus_dx2;
}
y++;
}
}
}
else
{

if (dx >= -dy)
{
F = -dy2 - dx;

x = p1x;
y = p1y;
while (x <= p2x)
{
PutPixelMode0(x, y, 1);
if (F <= 0)
{
F -= dy2;
}
else
{
y--;
F -= dy2_plus_dx2;
}
x++;
}
}


else
{
F = dx2 + dy;

y = p1y;
x = p1x;
while (y >= p2y)
{
PutPixelMode0(x, y, 1);
if (F <= 0)
{
F += dx2;
}
else
{
x++;
F += dy2_plus_dx2;
}
y--;
}
}
}
}




main()
{
#asm


ld a, 0
call $BC0E
#endasm


lineBresenham(0, 0, 159, 199);
lineBresenham(0, 199, 159, 0);
lineBresenham(80, 0, 80, 199);
lineBresenham(0, 100, 159, 100);

while(1) {};
}
